/*
 *  -:- LICENCE -:- 
 * Copyright Raffi Enficiaud 2007-2009
 * 
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file ../../../LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
 * 
 *  -:- LICENCE -:- 
 */



#ifndef YAYI_IO_HPP__
#define YAYI_IO_HPP__

#include <Yayi/core/yayiImageCore/include/yayiImageCore.hpp>



#ifdef YAYI_EXPORT
#define YIO_ MODULE_EXPORT
#else
#define YIO_ MODULE_IMPORT
#endif





namespace yayi
{
  namespace IO
  {






    YIO_ yaRC readPNG (const string_type &filename, IImage*& image);
    YIO_ yaRC writePNG(const string_type &filename, const IImage*& image);

    YIO_ yaRC readJPG (const string_type &filename, IImage*& image);
    YIO_ yaRC writeJPG(const string_type &filename, const IImage* const & image);




    YIO_ yaRC readRAW (const string_type &filename, const std::vector<int> &sizes, const int format);
    YIO_ yaRC writeRAW(const string_type &filename, const IImage *&image);


  }
}




#endif