/*
 *  -:- LICENCE -:- 
 * Copyright Raffi Enficiaud 2007-2009
 * 
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file ../../../LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
 * 
 *  -:- LICENCE -:- 
 */


#ifndef YAYI_PIXEL_IMAGE_CONSTANT_T_HPP__
#define YAYI_PIXEL_IMAGE_CONSTANT_T_HPP__


#include <algorithm>
#include <Yayi/core/yayiPixelProcessing/include/pixel_simple_T.hpp>
#include <Yayi/core/yayiImageCore/include/ApplyToImage_T.hpp>


namespace yayi
{

  template <class pixel_in>
    struct s_constant : public std::unary_function<pixel_in, void>
  {
    const pixel_in value;

    s_constant(const pixel_in &v_) : value(v_){}
    void operator()(pixel_in& p) const
    {
      p = value;
    }
  };


  template <class image_in_out_, class T>
    yaRC constant_image_t(const T& value_, image_in_out_& im)
  {
    typedef s_constant<typename image_in_out_::pixel_type>  operator_type;
    s_apply_unary_operator                                  op_processor;
    
    operator_type op(static_cast<typename image_in_out_::pixel_type>(value_));
    return op_processor(im, op);
  }

}

#endif
