/*
 *  -:- LICENCE -:- 
 * Copyright Raffi Enficiaud 2007-2009
 * 
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file ../../../LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
 * 
 *  -:- LICENCE -:- 
 */

#ifndef YAYI_PIXEL_IMAGE_COPY_T_HPP__
#define YAYI_PIXEL_IMAGE_COPY_T_HPP__



#include <algorithm>
#include <Yayi/core/yayiPixelProcessing/include/pixel_simple_T.hpp>


namespace yayi
{

  template <class pixel_in, class pixel_out>
    struct s_copy : public std::unary_function<pixel_in, pixel_out>
  {
    pixel_out operator()(const pixel_in& p) const
    {
      return static_cast<pixel_out>(p);
    }
  };


  template <class image_in_, class image_out_>
    yaRC copy_image_t(const image_in_& imin, image_out_& imout)
  {
    s_copy<typename image_in_::pixel_type, typename image_out_::pixel_type> op;
    return pixel_processor(imin, op, imout);
  }

}

#endif