/*
 *  -:- LICENCE -:- 
 * Copyright Raffi Enficiaud 2007-2009
 * 
 * Distributed under the Boost Software License, Version 1.0.
 * (See accompanying file ../../LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
 * 
 *  -:- LICENCE -:- 
 */


#include "main.hpp"
#include "Yayi/core/yayiImageCore/include/yayiImageCore_Impl.hpp"
#include "Yayi/core/yayiImageCore/include/yayiImageUtilities_T.hpp"

#include <iostream>

using namespace yayi;


void test_image_same_type() {
  BOOST_CHECKPOINT("test_image_same_type");	
  Image<yaINT16> im, im2;
  Image<yaUINT8> im3, im4;
  
  BOOST_CHECK(are_images_same_type(im, im2));
  BOOST_CHECK(are_images_same_type(im3, im4));
  BOOST_CHECK(!are_images_same_type(im, im3));

  
}

void test_image_same() {
  BOOST_CHECKPOINT("test_image_same");
  Image<yaINT16> im, im2;
  Image<yaUINT8> im3, im4;
  BOOST_CHECK(!are_images_same(im, im2));
  BOOST_CHECK(!are_images_same(im3, im4));
  BOOST_CHECK(are_images_same(im3, im3));
}




void register_image_utility_test(test_suite*& test) {
  test->add( BOOST_TEST_CASE( test_image_same_type ) );
  test->add( BOOST_TEST_CASE( test_image_same ) );
  
}


